/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
/**
 * @file Call.h
 *
 * This file Contains the Call class and equivalent C function tables
 * that all web service stubs generated by WSDL2Ws tool use to talk
 * to Axis Engine.
 *
 */
/*
 * Revision 1.1  2004/05/24 samisa
 * Added accesser to transport 
 */
/*
 * Revision 1.2  2004/05/25 samisa
 * Added accesser to SOAP serializer 
 */
/*
 * Revision 1.3  2004/05/31 samisa
 * Added setProxy
 */
/* Call.h: interface for the Call class.*/
#ifndef CALL_INCLUDED
#define CALL_INCLUDED


AXISC_STORAGE_CLASS_INFO void axiscSetSOAPVersionCallBase(AXISCHANDLE callBase, AXISC_SOAP_VERSION version);
AXISC_STORAGE_CLASS_INFO int axiscSetTransportPropertyCallBase(AXISCHANDLE callBase, AXISC_TRANSPORT_INFORMATION_TYPE type, 
	const char * value);
AXISC_STORAGE_CLASS_INFO int axiscSetHandlerPropertyCallBase(AXISCHANDLE callBase, AxiscChar * name, 
	void * value, int len);
AXISC_STORAGE_CLASS_INFO int axiscSetProtocolCallBase(AXISCHANDLE callBase, AXISC_PROTOCOL_TYPE protocol);
AXISC_STORAGE_CLASS_INFO int axiscInitializeCallBase(AXISCHANDLE callBase, AXISC_PROVIDERTYPE nStyle);
AXISC_STORAGE_CLASS_INFO int axiscInvokeCallBase(AXISCHANDLE callBase);
AXISC_STORAGE_CLASS_INFO int axiscUnInitializeCallBase(AXISCHANDLE callBase);

/* Method that set the remote method name */
AXISC_STORAGE_CLASS_INFO void axiscSetOperationCallBase(AXISCHANDLE callBase, const char * pchOperation, 
	const char * pchNamespace);
AXISC_STORAGE_CLASS_INFO int axiscSetEndpointURICallBase(AXISCHANDLE callBase, const char * pchEndpointURI);

/* Method for adding complex parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxParameterCallBase(AXISCHANDLE callBase, void * pObject, 
	void * pSZFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method for adding complex type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxArrayParameterCallBase(AXISCHANDLE callBase, Axisc_Array * pArray, 
	void * pSZFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method for adding basic type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddBasicArrayParameterCallBase(AXISCHANDLE callBase, Axisc_Array * pArray, 
	AXISC_XSDTYPE nType, const char * pName);

/* Method for adding parameters of basic types */
AXISC_STORAGE_CLASS_INFO void axiscAddParameterCallBase(AXISCHANDLE callBase, void * pValue, 
	const char * pName, AXISC_XSDTYPE nType);

/* Methods used by stubs to get a deserialized value of an XML element
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO xsdc__int * axiscGetElementAsIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean * axiscGetElementAsBooleanCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedInt * axiscGetElementAsUnsignedIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__short * axiscGetElementAsShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedShort * axiscGetElementAsUnsignedShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__byte * axiscGetElementAsByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedByte * axiscGetElementAsUnsignedByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__long * axiscGetElementAsLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__integer * axiscGetElementAsIntegerCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedLong * axiscGetElementAsUnsignedLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__float * axiscGetElementAsFloatCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__double * axiscGetElementAsDoubleCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__decimal * axiscGetElementAsDecimalCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__string axiscGetElementAsStringCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__anyURI axiscGetElementAsAnyURICallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__QName axiscGetElementAsQNameCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary * axiscGetElementAsHexBinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary * axiscGetElementAsBase64BinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__dateTime * axiscGetElementAsDateTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__date * axiscGetElementAsDateCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__time * axiscGetElementAsTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__duration * axiscGetElementAsDurationCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Methods used by stubs to get a deserialized value of XML attribute
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO xsdc__int * axiscGetAttributeAsIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean * axiscGetAttributeAsBooleanCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedInt * axiscGetAttributeAsUnsignedIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__short * axiscGetAttributeAsShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedShort * axiscGetAttributeAsUnsignedShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__byte * axiscGetAttributeAsByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedByte * axiscGetAttributeAsUnsignedByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__long * axiscGetAttributeAsLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__integer * axiscGetAttributeAsIntegerCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedLong * axiscGetAttributeAsUnsignedLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__float * axiscGetAttributeAsFloatCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__double * axiscGetAttributeAsDoubleCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__decimal * axiscGetAttributeAsDecimalCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__string axiscGetAttributeAsStringCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__anyURI axiscGetAttributeAsAnyURICallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__QName axiscGetAttributeAsQNameCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary * axiscGetAttributeAsHexBinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary * axiscGetAttributeAsBase64BinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__dateTime * axiscGetAttributeAsDateTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__date * axiscGetAttributeAsDateCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__time * axiscGetAttributeAsTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__duration * axiscGetAttributeAsDurationCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized value of complex types */
AXISC_STORAGE_CLASS_INFO void * axiscGetCmplxObjectCallBase(AXISCHANDLE callBase, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of complex types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetCmplxArrayCallBase(AXISCHANDLE callBase, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of basic types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetBasicArrayCallBase(AXISCHANDLE callBase, AXISC_XSDTYPE nType, 
	const AxiscChar * pName, const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscCheckMessageCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO void * axiscCheckFaultCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Minimal error check */
AXISC_STORAGE_CLASS_INFO int axiscGetStatusCallBase(AXISCHANDLE callBase);
AXISC_STORAGE_CLASS_INFO AxiscAnyType * axiscGetAnyObjectCallBase(AXISCHANDLE callBase);
AXISC_STORAGE_CLASS_INFO int axiscAddAnyObjectCallBase(AXISCHANDLE callBase, AxiscAnyType * pAnyObject);
AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetNamespacePrefixCallBase(AXISCHANDLE callBase, const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateHeaderBlockCallBase(AXISCHANDLE callBase, AxiscChar * pachLocalName, 
	AxiscChar * pachUri, AxiscChar * pachPrefix);

/* A separate call class object should be used by each thread */
AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateCall();
AXISC_STORAGE_CLASS_INFO void axiscDestroyCall(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO void axiscSetSOAPVersionCall(AXISCHANDLE call, AXISC_SOAP_VERSION version);
AXISC_STORAGE_CLASS_INFO int axiscSetTransportPropertyCall(AXISCHANDLE call, AXISC_TRANSPORT_INFORMATION_TYPE type, 
	const char * value);
AXISC_STORAGE_CLASS_INFO const char * axiscGetTransportPropertyCall(AXISCHANDLE call, const char * key, 
	AxiscBool response);
AXISC_STORAGE_CLASS_INFO int axiscSetHandlerPropertyCall(AXISCHANDLE call, AxiscChar * name, 
	void * value, int len);

/**
	 * set the protocol that the underlying transport will use. 
	 * If there is not transport set then the transport protocol is stored locally until there is a transport.
	 * 
	 * @param protocol the protocol that you want. Allowed values are  defined in GDefine.hpp AXIS_PROTOCOL_TYPE
	 * @return AXIS_SUCCESS if the protocol was set correctly in the underlying transport or, if there is no transport then the value was stored safely.
	 */
AXISC_STORAGE_CLASS_INFO int axiscSetProtocolCall(AXISCHANDLE call, AXISC_PROTOCOL_TYPE protocol);

/**
     * Get the protocol that the transport is or will use.
     * @return the transport protocol being used.
     */
AXISC_STORAGE_CLASS_INFO AXISC_PROTOCOL_TYPE axiscGetProtocol(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO int axiscUnInitializeCall(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO int axiscInitializeCall(AXISCHANDLE call, AXISC_PROVIDERTYPE nStyle);
AXISC_STORAGE_CLASS_INFO int axiscInvokeCall(AXISCHANDLE call);

/**
     * Sets an Attribute to the SOAPMethod, using the given Attribute data.
     * You must ensure the prefix has a valid namespace declared, otherwise an
     * invalid SOAP message will be produced.
     * It is safer to use setSOAPMethodAttribute(const AxisChar *pLocalname, const AxisChar *pPrefix, const AxisChar* pUri, const AxisChar *pValue)
     * 
     * @param pLocalname The local name of the Attribute.
     * @param pPrefix The prefix of the Attribute.
     * @param pValue The value of the Attribute.
     */

/**
     * Sets an Attribute to the SOAPMethod, using the given Attribute data.
     *
     * @param pLocalname The local name of the Attribute.
     * @param pPrefix The prefix of the Attribute.
     * @param pUri The namespace uri of the Attribute.
     * @param pValue The value of the Attribute.
     */
AXISC_STORAGE_CLASS_INFO void axiscSetSOAPMethodAttribute(AXISCHANDLE call, const AxiscChar * pLocalname, 
	const AxiscChar * pPrefix, const AxiscChar * pUri, 
	const AxiscChar * pValue);

/* Method for adding complex parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxParameterCall(AXISCHANDLE call, void * pObject, 
	void * pSZFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method for adding complex type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxArrayParameterCall(AXISCHANDLE call, Axisc_Array * pArray, 
	void * pSZFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method for adding basic type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddBasicArrayParameterCall(AXISCHANDLE call, Axisc_Array * pArray, 
	AXISC_XSDTYPE nType, const AxiscChar * pName);

/* Method for adding parameters of basic types */
AXISC_STORAGE_CLASS_INFO void axiscAddParameterCall(AXISCHANDLE call, void * pValue, 
	const char * pchName, AXISC_XSDTYPE nType);

/* Method that set the remote method name */
AXISC_STORAGE_CLASS_INFO void axiscSetOperationCall(AXISCHANDLE call, const char * pchOperation, 
	const char * pchNamespace);
AXISC_STORAGE_CLASS_INFO int axiscSetEndpointURICall(AXISCHANDLE call, const char * pchEndpointURI);
AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateHeaderBlockCall(AXISCHANDLE call, AxiscChar * pachLocalName, 
	AxiscChar * pachUri, AxiscChar * pachPrefix);

/* Methods used by stubs to get a deserialized value of XML element
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO xsdc__int * axiscGetElementAsIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean * axiscGetElementAsBooleanCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedInt * axiscGetElementAsUnsignedIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__short * axiscGetElementAsShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedShort * axiscGetElementAsUnsignedShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__byte * axiscGetElementAsByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedByte * axiscGetElementAsUnsignedByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__long * axiscGetElementAsLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__integer * axiscGetElementAsIntegerCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedLong * axiscGetElementAsUnsignedLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__float * axiscGetElementAsFloatCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__double * axiscGetElementAsDoubleCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__decimal * axiscGetElementAsDecimalCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__string axiscGetElementAsStringCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__anyURI axiscGetElementAsAnyURICall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__QName axiscGetElementAsQNameCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary * axiscGetElementAsHexBinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary * axiscGetElementAsBase64BinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__dateTime * axiscGetElementAsDateTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__date * axiscGetElementAsDateCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__time * axiscGetElementAsTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__duration * axiscGetElementAsDurationCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Methods used by stubs to get a deserialized value of a XML attribute
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO xsdc__int * axiscGetAttributeAsIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean * axiscGetAttributeAsBooleanCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedInt * axiscGetAttributeAsUnsignedIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__short * axiscGetAttributeAsShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedShort * axiscGetAttributeAsUnsignedShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__byte * axiscGetAttributeAsByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedByte * axiscGetAttributeAsUnsignedByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__long * axiscGetAttributeAsLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__integer * axiscGetAttributeAsIntegerCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__unsignedLong * axiscGetAttributeAsUnsignedLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__float * axiscGetAttributeAsFloatCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__double * axiscGetAttributeAsDoubleCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__decimal * axiscGetAttributeAsDecimalCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__string axiscGetAttributeAsStringCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__anyURI axiscGetAttributeAsAnyURICall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__QName axiscGetAttributeAsQNameCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary * axiscGetAttributeAsHexBinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary * axiscGetAttributeAsBase64BinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__dateTime * axiscGetAttributeAsDateTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__date * axiscGetAttributeAsDateCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__time * axiscGetAttributeAsTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__duration * axiscGetAttributeAsDurationCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized value of complex types */
AXISC_STORAGE_CLASS_INFO void * axiscGetCmplxObjectCall(AXISCHANDLE call, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of complex types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetCmplxArrayCall(AXISCHANDLE call, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of basic types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetBasicArrayCall(AXISCHANDLE call, AXISC_XSDTYPE nType, 
	const AxiscChar * pName, const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscCheckMessageCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO void * axiscCheckFaultCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscGetStatusCall(AXISCHANDLE call);

/**
    * Set proxy server and port for transport.
    *
    * @param pcProxyHost Host name of proxy server
    * @param uiProxyPort Port of proxy server
    */
AXISC_STORAGE_CLASS_INFO void axiscSetProxyCall(AXISCHANDLE call, const char * pcProxyHost, 
	unsigned int uiProxyPort);
AXISC_STORAGE_CLASS_INFO AxiscAnyType * axiscGetAnyObjectCall(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO int axiscAddAnyObjectCall(AXISCHANDLE call, AxiscAnyType * pAnyObject);

/**
	 * Returns the prefix for a previously defined namespace. If the 
	 * namespace has not previously been associated with a prefix, it
	 * creates a new prefix, which is unique and returns that. It will
	 * only return prefixes for user-defined namespaces, so passing a 
	 * standard namespace will cause a new prefix to be created.
	 * 
	 * @param pNamespace the namespace to look for
	 * @return the prefix for this namespace
	 */
AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetNamespacePrefixCall(AXISCHANDLE call, const AxiscChar * pNamespace);

/**
	 * Returns a complex fault as an XML string 
	 */
AXISC_STORAGE_CLASS_INFO const xsdc__string axiscGetFaultAsXMLString(AXISCHANDLE call);


/*
       Following are pointers to relevant objects of the ClientAxisEngine
       instance. So they do not belong to this object and are not created
       or deleted
     */
/*
       Transport object
     */
/* Minimal error check */
/**
    * Proxy server name.
    */
/**
    * Proxy server port.
    */
/**
    * Use Proxy or not?
    */
/**
    * To track if the initialize was called/matched with an uninitialize
    */
// Samisa m_pchSessionID was misssing and there was a compile error due to this


#endif // CALL_INCLUDED
